/* Utils.c generated by valac 0.56.14, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2018–2022 Cassidy James Blaede <c@ssidyjam.es>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	DIPPI_UTILS_DISPLAY_TYPE_INTERNAL,
	DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL
} DippiUtilsDisplayType;

#define DIPPI_UTILS_TYPE_DISPLAY_TYPE (dippi_utils_display_type_get_type ())

VALA_EXTERN GType dippi_utils_display_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* dippi_utils_display_type_to_string (DippiUtilsDisplayType self);
VALA_EXTERN gchar* dippi_utils_display_type_icon_suffix (DippiUtilsDisplayType self);
VALA_EXTERN gint dippi_utils_dpi (gdouble inches,
                      gint width,
                      gint height);
VALA_EXTERN gint dippi_utils_greatest_common_divisor (gint a,
                                          gint b);

gchar*
dippi_utils_display_type_to_string (DippiUtilsDisplayType self)
{
	gchar* result;
#line 12 "../src/Utils.vala"
	switch (self) {
#line 12 "../src/Utils.vala"
		case DIPPI_UTILS_DISPLAY_TYPE_INTERNAL:
#line 58 "Utils.c"
		{
			gchar* _tmp0_;
#line 14 "../src/Utils.vala"
			_tmp0_ = g_strdup (_ ("Laptop"));
#line 14 "../src/Utils.vala"
			result = _tmp0_;
#line 14 "../src/Utils.vala"
			return result;
#line 67 "Utils.c"
		}
#line 12 "../src/Utils.vala"
		case DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL:
#line 71 "Utils.c"
		{
			gchar* _tmp1_;
#line 17 "../src/Utils.vala"
			_tmp1_ = g_strdup (_ ("Desktop"));
#line 17 "../src/Utils.vala"
			result = _tmp1_;
#line 17 "../src/Utils.vala"
			return result;
#line 80 "Utils.c"
		}
		default:
		{
#line 20 "../src/Utils.vala"
			g_assert_not_reached ();
#line 86 "Utils.c"
		}
	}
}

gchar*
dippi_utils_display_type_icon_suffix (DippiUtilsDisplayType self)
{
	gchar* result;
#line 25 "../src/Utils.vala"
	switch (self) {
#line 25 "../src/Utils.vala"
		case DIPPI_UTILS_DISPLAY_TYPE_INTERNAL:
#line 99 "Utils.c"
		{
			gchar* _tmp0_;
#line 27 "../src/Utils.vala"
			_tmp0_ = g_strdup ("-notebook");
#line 27 "../src/Utils.vala"
			result = _tmp0_;
#line 27 "../src/Utils.vala"
			return result;
#line 108 "Utils.c"
		}
#line 25 "../src/Utils.vala"
		case DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL:
#line 112 "Utils.c"
		{
			gchar* _tmp1_;
#line 30 "../src/Utils.vala"
			_tmp1_ = g_strdup ("");
#line 30 "../src/Utils.vala"
			result = _tmp1_;
#line 30 "../src/Utils.vala"
			return result;
#line 121 "Utils.c"
		}
		default:
		{
#line 33 "../src/Utils.vala"
			g_assert_not_reached ();
#line 127 "Utils.c"
		}
	}
}

static GType
dippi_utils_display_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DIPPI_UTILS_DISPLAY_TYPE_INTERNAL, "DIPPI_UTILS_DISPLAY_TYPE_INTERNAL", "internal"}, {DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL, "DIPPI_UTILS_DISPLAY_TYPE_EXTERNAL", "external"}, {0, NULL, NULL}};
	GType dippi_utils_display_type_type_id;
	dippi_utils_display_type_type_id = g_enum_register_static ("DippiUtilsDisplayType", values);
	return dippi_utils_display_type_type_id;
}

GType
dippi_utils_display_type_get_type (void)
{
	static volatile gsize dippi_utils_display_type_type_id__once = 0;
	if (g_once_init_enter (&dippi_utils_display_type_type_id__once)) {
		GType dippi_utils_display_type_type_id;
		dippi_utils_display_type_type_id = dippi_utils_display_type_get_type_once ();
		g_once_init_leave (&dippi_utils_display_type_type_id__once, dippi_utils_display_type_type_id);
	}
	return dippi_utils_display_type_type_id__once;
}

gint
dippi_utils_dpi (gdouble inches,
                 gint width,
                 gint height)
{
	gdouble unrounded_dpi = 0.0;
	gint rounded_dpi = 0;
	gint result;
#line 39 "../src/Utils.vala"
	unrounded_dpi = sqrt (pow ((gdouble) width, (gdouble) 2) + pow ((gdouble) height, (gdouble) 2)) / inches;
#line 43 "../src/Utils.vala"
	rounded_dpi = (gint) unrounded_dpi;
#line 45 "../src/Utils.vala"
	result = rounded_dpi;
#line 45 "../src/Utils.vala"
	return result;
#line 169 "Utils.c"
}

gint
dippi_utils_greatest_common_divisor (gint a,
                                     gint b)
{
	gint result;
#line 49 "../src/Utils.vala"
	if (a == 0) {
#line 50 "../src/Utils.vala"
		result = b;
#line 50 "../src/Utils.vala"
		return result;
#line 183 "Utils.c"
	}
#line 53 "../src/Utils.vala"
	if (b == 0) {
#line 54 "../src/Utils.vala"
		result = a;
#line 54 "../src/Utils.vala"
		return result;
#line 191 "Utils.c"
	}
#line 57 "../src/Utils.vala"
	if (a > b) {
#line 58 "../src/Utils.vala"
		result = dippi_utils_greatest_common_divisor (a % b, b);
#line 58 "../src/Utils.vala"
		return result;
#line 199 "Utils.c"
	} else {
#line 60 "../src/Utils.vala"
		result = dippi_utils_greatest_common_divisor (a, b % a);
#line 60 "../src/Utils.vala"
		return result;
#line 205 "Utils.c"
	}
}

